// Modul...: SSP_MASTER.C
// Version.: 1.0
// Compiler: KEIL-ARM
// Datum...: Dezember 2005
// Autor...: Udo Jrss / Ulrich Radig
//-----------------------------------------------------------------------------

#include "ssp_master.h"
#include "pal.h"

//-----------------------------------------------------------------------------

//static pU08 ssp_write_buffer_ptr; // Zeiger auf Schreibpuffer
static U32 ssp_bytes_to_write; // Anzahl Datenbytes
//------------------------------------------------------------------------------
void ssp_master_init(U08 data_format)
{  
  PCONP |= PCSPI1; // SPI1 einschalten

  PINSEL1 |= SPI1_IOSET_MASK; // PIN Konfigurieren
  SSPCPSR = 2; // Clock Prescale Register setzten
  SSPCR0 = data_format | CPHA | FRF_SPI; // SPI-Format
  SSPCR1 = SSE; // Schnittstelle als Master aktivieren

  while (SSPSR & RNE) // Rx-FIFO leeren
  {
    SSPDR; // Dummy-Read
  }
}
//-----------------------------------------------------------------------------

void ssp_transfer(pU08 write_buffer_ptr)
{                      
  ssp_bytes_to_write = PAL_CHAR_COLS / 2;

  while (!(SSPSR & TNF));
  SSPDR = 0x0;
  SSPDR = 0x0;
  SSPDR = 0x0;

  while (ssp_bytes_to_write--)
  {
  	while(!(SSPSR & TNF));
    SSPDR = (U16)(*write_buffer_ptr++ << 8)+
			(*write_buffer_ptr++); // Datenbyte in den Tx-FIFO schreiben 
  }
}